local _,L = ...
local rematch = Rematch

-- call during initialization to set text, size and position of all tabs;
-- it also makes the parent frame fit around the tabs (set noAutoSize
-- keyvalue to parent frame to prevent this)
function rematch:SetupPanelTabs(frame,activeIndex,...)
	local totalWidth = 0
	for i=1,select("#",...) do
		local button = frame.Tabs[i]
		button.Text:SetText((select(i,...)))
		local width = max(76,button.Text:GetStringWidth()+40)
		button:SetWidth(width)
		totalWidth = totalWidth + (width-16)
		local index = button:GetID()
		if index==1 then
			button:SetPoint("TOPLEFT")
		elseif index>1 then
			button:SetPoint("LEFT",frame.Tabs[index-1],"RIGHT",-16,0)
		end
	end
	frame.activeTab = activeIndex or 1
	if not frame.noAutoSize then
		frame:SetWidth(totalWidth+16)
	end
end

function rematch:UpdatePanelTabs(parent)
	for i=1,#parent.Tabs do
		local button = parent.Tabs[i]
		local active = parent.activeTab==i
		for i=1,3 do
			button.Inactive[i]:SetShown(not active)
			button.Active[i]:SetShown(active and true)
		end
		button.Text:SetPoint("CENTER",0,active and -3 or 2)
		button.Highlight:SetPoint("BOTTOMRIGHT",-12,active and 1 or 7)
		button:SetNormalFontObject(active and GameFontHighlightSmall or GameFontNormalSmall)
	end
end

-- call when a tab clicked (unless tab shouldn't select like MiniPanel)
function rematch:SelectPanelTab(parent,index)
	parent.activeTab = index
	rematch:UpdatePanelTabs(parent)
end

-- returns the currently selected tab
function rematch:GetSelectedPanelTab(parent)
	return parent.activeTab
end